#ifdef STANDARD
#include <stdio.h>
#include <string.h>
#ifdef __WIN__
typedef unsigned __int64 ulonglong;     /* Microsofts 64 bit types */
typedef __int64 longlong;
#else
typedef unsigned long long ulonglong;
typedef long long longlong;
#endif /*__WIN__*/
#else
#include <my_global.h>
#include <my_sys.h>
#endif
#include <mysql.h>
#include <m_ctype.h>
#include <m_string.h>           // To get strmov()

/*
#include <mysql.h>
#include <stdio.h>
#include <string.h>
*/

/* this avoid a warning about the use of asm functions on non-kernel mode */
/*
#undef HAVE_ATOMIC_ADD
*/

#undef BEGIN_C_DECLS
#undef END_C_DECLS
#ifdef __cplusplus
# define BEGIN_C_DECLS extern "C" {
# define END_C_DECLS }
#else
# define BEGIN_C_DECLS /* empty */
# define END_C_DECLS /* empty */
#endif

#ifdef HAVE_DLOPEN

#define HELLO_STR "Hello "
#define HELLO_STRLEN 6

BEGIN_C_DECLS

my_bool hello_init( UDF_INIT* initid, UDF_ARGS* args, char* message );
void hello_deinit( UDF_INIT* initd );
char* hello( UDF_INIT* initid, UDF_ARGS* args, char* result, unsigned long* length, char* is_null, char* error );

END_C_DECLS

my_bool hello_init( UDF_INIT* initid, UDF_ARGS* args, char* message )
{
	if ( args->arg_count != 1 || args->arg_type[0] != STRING_RESULT ) {
		strcpy( message, "Wrong arguments to hello; give a name" );
		return 1;
	}

	initid->max_length = HELLO_STRLEN + strlen( args->args[0] );

	return 0;
}

void hello_deinit( UDF_INIT* initid )
{
	/* empty */
}

char* hello( UDF_INIT* initid, UDF_ARGS* args, char* result, unsigned long* length, char* is_null, char* error )
{
	sprintf( result, "%s%s", HELLO_STR, args->args[0] );
	*length = strlen( result );

	return result;
}

#endif /* HAVE_DLOPEN */
